/*
 * collector.c
 *                   Dummy collector for nova development
 *                             Masaharu Nomachi (KEK)
 *                             5-JUN-1992
 *
 *              version 0.31  23-JUN-1992 Yasuo TAKEUCHI     (T.I.T.)
 *              version 1.10   2-Jul-1994 Yasuo TAKEUCHI     (T.I.T.)
 */
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <errno.h>
#include "nova.h"

#define DEFAULT_NAME          "/tmp/nova"
#define DEFAULT_SIGNIFICANCE  70
#define PRI_COLLECTOR         -1

main(argc, argv) int argc; char *argv[];{
    struct NOVAD *nd;
    int *data1,*data2, length1, length2;
    int status, loop, i, significance;
    char name[NV_MAXNAME + 1];

    strcpy(name, (argc > 1) ? argv[1] : DEFAULT_NAME);
    significance = (argc > 2) ? atoi(argv[2]) : DEFAULT_SIGNIFICANCE; 

    if ((int)(nd = nova_open(name, PRI_COLLECTOR, 2)) == -1) {
	printf("collector: cannot open %s", name);
	exit(1);
    }

    for (loop = 1; 1; loop++) {
	status  = nova_get(nd, &data1, &length1);
	
	switch (status) {
	  case 0:   /* nomal */
	    printf("collector: loop=%d  status=%d  length1=%d byte\n",
		   loop, status, length1);
	    status  = nova_get(nd, &data2, &length2);
	    switch (status) {
	      case 0:   /* nomal */
		printf("collector: loop=%d  status=%d  length2=%d byte\n",
		       loop, status, length2);

		status = nova_put(nd, data2, 400, significance);
		if (status<0) 
		  printf("collector: put error status=%d n",status);
		printf(" put buffer 2\n");
		getchar();

		status = nova_put(nd, data1, 400, significance);
		if (status<0) 
		  printf("collector: put error status=%d n",status);
		printf(" put buffer 2\n");
		getchar();

		break;

	      case 1:   /* interrupted */
		printf("collector: interrupted 2!\n");
		break;
	      default:  /* error */
		printf("collector: error 2!\n");
		break;
	    }
	    break;
	  case 1:   /* interrupted */
	    printf("collector: interrupted 1!\n");
	    break;
	  default:  /* error */
	    printf("collector: error 1!\n");
	    break;
	}
	if (status<0) break;
	sleep(3);
	}
    
    printf("collector: nomal end.\n");
    nova_close(nd);
}
