/*
 * collector_fast.c
 *                   Dummy collector for nova development
 *                             Masaharu Nomachi (KEK)
 *                             5-JUN-1992
 *
 *              version 0.31  23-JUN-1992 Yasuo TAKEUCHI     (T.I.T.)
 */
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <errno.h>
#include "nova.h"

#define DEFAULT_NAME          "/tmp/nova"
#define DEFAULT_SIGNIFICANCE  70
#define DEFAULT_LOOP          10
#define DEFAULT_SIZE        1024
#define PRI_COLLECTOR         -1

main(argc, argv) int argc; char *argv[];{
  struct NOVAD *nd;
  int *data, length, size, sig;
  int status, loop, i, max_loop;
  char name[NV_MAXNAME + 1];
  
  max_loop   = (argc > 1) ? atoi(argv[1]) : DEFAULT_LOOP;
  size       = (argc > 2) ? atoi(argv[2]) : DEFAULT_SIZE;
  sig        = (argc > 3) ? atoi(argv[3]) : DEFAULT_SIGNIFICANCE;
  strcpy(name, (argc > 4) ? argv[4] : DEFAULT_NAME);
  
  if ((int)(nd = nova_open(name, PRI_COLLECTOR,1)) == -1) {
    printf("collector: cannot open %s", name);
    exit(1);
  }
  
  loop = 0;
  while(1) {
    if (loop>=max_loop) break;

    status = nova_get(nd, &data, &length);

    switch (status) {
    case 0:   /* nomal */
      loop++;
/*
      if (size < length) length = size;
      for(i = (length>>2)-1; i >= 0; --i) data[i] = loop + i;
*/
      status = nova_put(nd, data, length, sig);
      if (status<0) printf("collector: put error status=%d n",status);
      break;
    case 1:   /* interrupted */
      printf("collector: interrupted!\n");
      break;
    default:  /* error */
      printf("collector: error!\n");
      break;
    }
    if (status<0) break;
  }
  printf("collector: nomal end. loop=%d size = %d total %dKbyte\n",
	 loop, size,loop*size/1000);
  nova_close(nd);
}
