/*
 * collector_size.c
 *                   Dummy collector for nova development
 *                             Masaharu Nomachi (KEK)
 *                             5-JUN-1992
 *
 *              version 0.31  23-JUN-1992 Yasuo TAKEUCHI     (T.I.T.)
 *              version 1.10   2-Jul-1994 Yasuo TAKEUCHI     (T.I.T.)
 *              version 1.10sk  15-May-1995  Yasuo Takeuchi     (ICRR)
 */
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <errno.h>
#include "nova.h"

#define DEFAULT_NAME          "/tmp/nova"
#define DEFAULT_SIGNIFICANCE  70
#define PRI_COLLECTOR         -1

#define MAX_RETRY 10     /* maximum retry count for nova_set_length() */

main(argc, argv) int argc; char *argv[];{
    struct NOVAD *nd;
    int *data, length;
    int loop = 0;
    int status, i, significance, retry;
    char name[NV_MAXNAME + 1];

    /* read option */
    strcpy(name, (argc > 1) ? argv[1] : DEFAULT_NAME);
    significance = (argc > 2) ? atoi(argv[2]) : DEFAULT_SIGNIFICANCE; 

    /* initialize */
    if ((int)(nd = nova_open(name, PRI_COLLECTOR,1)) == -1) {
	printf("collector: cannot open %s", name);
	exit(1);
    }


/*
    for (loop = 1; 1; loop++) {
	rewind(stdin);
	printf(" input size = ");
	scanf("%d", &length);
	nova_set_length(nd, length);
*/

    /*******************
     * main loop       *
     *******************/
    for (length = 1000; length <= 6000000; length+=1000) {
	loop++;

	/* set buffer length at nova_get() */
	retry = 0;
	while (nova_set_length(nd, length) < 0 && retry < MAX_RETRY) {
	    fprintf(stderr, "set_length error!!  length=%d  retry=%d\n",
		    length, retry++);
	}
	if (retry >= MAX_RETRY) {
	    fprintf(stderr, "retry count over!\n");
	    exit(1);
	}
    
	/* get a free buffer */
	status = nova_get(nd, &data, &length);

	/* check status */
	switch (status) {
	  case 0:   /* nomal */
/****
	    printf("collector: loop=%d  status=%d  length=%d byte\n",
		   loop, status, length);
	    for(i = 0; i < 10; i++)
	      data[i] = loop + i;
****/
	    status = nova_put(nd, data, length, significance);
	    if (status<0) printf("collector: put error status=%d n",status);
	    break;
	  case 1:   /* interrupted */
	    printf("collector: interrupted!\n");
	    break;
	  default:  /* error */
	    alarm(0);
	    printf("collector: error!\n");
	    break;
	}
	if (status<0) break;
/*	sleep(3); */
    }
    
    printf("collector: nomal end. loop=%d\n", loop);
    nova_close(nd);
}
