/*
 * collector_val.c
 *                   Dummy collector for variable nova development
 *                             Masaharu Nomachi (KEK)
 *                             5-JUN-1992
 *
 *              version 0.31  23-JUN-1992 Yasuo TAKEUCHI     (T.I.T.)
 *		version 0.32  10-JUN-1995 Yoshiyuki Fukuda (I.C.R.R)
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <sys/time.h>
#include <errno.h>
#include "nova.h"

#define DEFAULT_NAME          "/tmp/nova"
#define DEFAULT_SIGNIFICANCE  70
#define DEFAULT_LOOP          10
#define DEFAULT_SIZE        1024
#define PRI_COLLECTOR         -1

main(argc, argv) int argc; char *argv[];{
  struct NOVAD *nd;
  struct timeval last, present;
  int *data, length, size, sig, masato[0x100000];
  int status, loop, i, max_loop, total_size = 0, init = 0;
  int difftime = 0;
  char name[NV_MAXNAME + 1];
  
  max_loop   = (argc > 1) ? atoi(argv[1]) : DEFAULT_LOOP;
  size       = (argc > 2) ? atoi(argv[2]) : DEFAULT_SIZE;
  sig        = (argc > 3) ? atoi(argv[3]) : DEFAULT_SIGNIFICANCE;
  strcpy(name, (argc > 4) ? argv[4] : DEFAULT_NAME);
  
  if ((int)(nd = nova_open(name, PRI_COLLECTOR,1)) == -1) {
    printf("collector: cannot open %s\n", name);
    exit(1);
  }
  
  loop = 0;
  while(1) {
    if (loop >= max_loop) break;
    status = nova_get(nd, &data, &length);
    switch (status) {
    case 0:   /* nomal */
      loop++;
      size = rand(); /* get random number */
      size = (int)((float)length * (float)size / 65535. );
      if (size != 0 && size < length) length = size;
      if(size == 0) length = size = 8;
      length  = length & 0xfffff;
      printf("length  = %d\n", length);
      memcpy(data, masato, length);
      status = nova_put(nd, data, length, sig);
      if (status < 0) {
	  printf("collector: put error status=%d\n",status);
      }
      else if(status >= 0) {
	total_size += length;
	gettimeofday(&present, NULL);
	if(init == 0) {
	    last.tv_usec = present.tv_usec;
	    last.tv_sec = present.tv_sec;
	    init = 1;
	    break; 
	}
	else {
	    difftime = present.tv_usec - last.tv_usec;
	    if(present.tv_sec > last.tv_sec) 
	      difftime += 1000000 * (present.tv_sec-last.tv_sec);
/*	    printf("collector: %6d byte total:%8d byte %9.1f byte/sec\n ", 
		   length, total_size, 
		   (double)(total_size)/(double)difftime*1000000.); */
	}
      }
      break;
    case 1:   /* interrupted */
      printf("collector: interrupted!\n");
      break;
    default:  /* error */
      printf("collector: error!\n");
      break;
    }
    if (status<0) break;
  }
  printf("collector: %6d byte total:%8d byte %9.1f loop/sec\n ", 
	 length, total_size, (double)(loop)/(double)difftime*1000000.);
  printf("collector: nomal end. loop=%d size = %d total %dKbyte\n",
	 loop, size,loop*size/1000);
  nova_close(nd);
}
