/*
 * bm_exec.h
 *                      Buffer manager link cell structures
 *
 *              version 1.03  05-OCT-1992 Masaharu NOMACHI   (kek)
 */

struct EXEC_process {
  struct EXEC_process *next;	   /* Forward ink pointer		*/
  struct EXEC_process *previous;   /* Backward link pointer		*/
  struct BMT_process  *table;      /* Process pointer table	        */
  int type, priority;		   /* Process type and priority       	*/
  int n_request, n_active;	   /* # of active buffer, request	*/
  struct EXEC_buffer *active;	   /* Waiting "done" buffer queue top	*/
  struct EXEC_buffer *wait;	   /* Waiting "send" buffer queue top	*/
  int status;                      /* status                            */
};

struct EXEC_buffer {
  struct EXEC_buffer *next;	   /* Forward ink pointer		*/
  struct EXEC_buffer *previous;    /* Backward link pointer		*/
  struct BMT_buffer  *table;       /* buffer pointer table     		*/
  int type, significance;	   /* Buffer type and significance	*/
  int status;			   /* Buffer status			*/
  int offset,size,max_size;        /* Buffer offset & size              */
};

#define NULL_process	((struct EXEC_process *)0)
#define NULL_buffer	((struct EXEC_buffer  *)0)

/* Process status */

#define PS_null		0	/* Unknown	                  */
#define PS_wait		0x10	/* Producer (Waiting new bufer)   */
#define	PS_busy 	0x18	/* Producer (Busy for processing) */
#define PS_producer	0x10	/* Producer process	          */
#define PS_consumer	0x20	/* Consumer process	          */

/* Buffer status */

#define BS_null		0	/* Unknown	*/
#define BS_wait		1	/* Waiting	*/
#define	BS_skip		2	/* Skipped	*/
#define BS_passed	3	/* Passed over	*/
#define BS_sent 	4	/* sent		*/






