/*
 * net_collector.c
 *                   Dummy collector for net nova development
 *
 *              version 1.03  09-OCT-1992 Masaharu NOMACHI (KEK)
 */
#include "nova.h"
#include "novanet.h"

#define DEFAULT_HOST          "psuxnc"
#define DEFAULT_NAME          "/tmp/nova"
#define DEFAULT_SIGNIFICANCE  70
#define PRI_COLLECTOR         -1

int data[16*1024];

main(argc, argv) int argc; char *argv[];{
  struct NOVAD *nd;
  int status, loop, i, significance;
  char name[NV_MAXNAME + 1];
  char host[NOVA_HOSTNAME_MAX + 1];

  strcpy(host, (argc > 1) ? argv[1] : DEFAULT_HOST);
  strcpy(name, (argc > 2) ? argv[2] : DEFAULT_NAME);
  significance = (argc > 3) ? atoi(argv[3]) : DEFAULT_SIGNIFICANCE; 

  if ((int)(nd = net_nova_open(host,0,name, PRI_COLLECTOR,1)) == -1) {
    printf("net collector: cannot open %s:%s\n", host, name);
    exit(1);
  }
  
  for (loop = 1; 1; loop++) {
    for(i = 0; i < 100; i++) data[i] = loop + i;
    printf("collector: loop=%d \n", loop);
    status = net_nova_write(nd, data, 400, significance);
    if (status<0) {
      printf("net_collector: put error status=%d \n",status);
      break;
    }
    else if (status == 0) {
      printf("net_collector: Disconnected ");
      break;
    }
    sleep(3);
  }
  printf("collector: nomal end.\n");
  net_nova_close(nd);
}
